#include "LCD_driver.h"
#include "FSIO.h"
#include "dpf.h"

void initBoard(void);

//HACKADAY: set custom configuration for PIC 24F
_CONFIG2(FNOSC_FRCPLL & OSCIOFNC_ON &POSCMOD_NONE)		// Internal FRC OSC with 4x PLL = 32MHz
_CONFIG1(JTAGEN_OFF & GCP_OFF & GWRP_OFF & COE_OFF & FWDTEN_OFF & ICS_PGx1) //turn off junk we don't need

int main(void){

//setup hardware
	initBoard();

	LCD_init(); //init the LCD

	while(1) dpfTasks();
}

void initBoard(void){
	CLKDIVbits.RCDIV0=0; //clock divider to 0
//HACKADAY:setup the pin assignment using peripheral pin select
	AD1PCFG = 0xFFFF;				//All digital inputs 
	OSCCONbits.SOSCEN=0;
	
	LATBbits.LATB13=0;//LED
	TRISBbits.TRISB13=0;
	
//HACKADAY:setup the pin assignment using peripheral pin select
	//SPI2 -> SD card
	// Inputs
	RPINR22bits.SDI2R = 11;			//SDI2	

	// Outputs
	#define PPSOB1 RPOR0bits.RP1R
	#define PPSOB2 RPOR1bits.RP2R
	#define PPSOB10 RPOR5bits.RP10R
	#define PPSOB9 RPOR4bits.RP9R
	PPSOB9 = SDO2_IO;		//SDO2
	PPSOB10 = SCK2OUT_IO; 	//SCK2
	
	// Lock the PPS
	asm volatile (	"mov #OSCCON,w1 \n"
					"mov #0x46, w2 \n"
					"mov #0x57, w3 \n"
					"mov.b w2,[w1] \n"
					"mov.b w3,[w1] \n"
					"bset OSCCON, #6");

 /*  // Turn on the secondary oscillator
   __asm__ ("MOV #OSCCON,w1");
   __asm__ ("MOV.b #0x02, w0");
   __asm__ ("MOV #0x46, w2");
   __asm__ ("MOV #0x57, w3");
   __asm__ ("MOV.b w2, [w1]");
   __asm__ ("MOV.b w3, [w1]");
   __asm__ ("MOV.b w0, [w1]");

   // Activate the RTCC module
   __asm__ ("mov #NVMKEY,W0");
   __asm__ ("mov #0x55,W1");
   __asm__ ("mov #0xAA,W2");
   __asm__ ("mov W1,[W0]");
   __asm__ ("nop");
   __asm__ ("mov W2,[W0]");
   __asm__ ("bset RCFGCAL,#13");
   __asm__ ("nop");
   __asm__ ("nop");
   RCFGCALbits.RTCPTR0 = 1;
   RCFGCALbits.RTCPTR1 = 1;
   // Set it to the correct time
   // These values won't be accurate
   RTCVAL = 0x0007;   
   RTCVAL = 0x0717;
   RTCVAL = 0x0208;
   RTCVAL = 0x2137;
   RCFGCAL = 0x8000;
*/
}
